<template>
  <div class="max-h-full min-h-full py-6 px-9 --text4" v-loading="isLoading">
    <h3 class="text-xl font-bold text-center fc-hint">
      {{ $t("you've_been_reward") }} {{ referralForDisplay }}!
    </h3>
    <div class="grid grid-cols-3 mt-5 text-center border-2 rounded-md">
      <div class="box-show-data">
        <h5 class="fc-primary">{{ $t("total") }}</h5>
        <h2>{{ totalRewardForDisplay }}</h2>
        <h6 class="flex items-center">
          <span class="pr-1 --text4">{{ $t("your_reward") }}</span>
          <el-tooltip>
            <template #content>
              <div class="flex flex-col --text4">
                <div>{{ $t("referral_count") }} : {{ referralCount }}</div>
                <div>{{ $t("reward") }} : {{ totalRewardForDisplay }}</div>
                <div>{{ $t("rebate") }} : {{ rebet }}</div>
              </div>
            </template>
            <font-awesome-icon icon="circle-info" />
          </el-tooltip>
        </h6>
      </div>
      <div class="box-show-data">
        <h5 class="fc-primary">{{ $t("redeemable") }}</h5>
        <h2>{{ redeemableForDisplay }}</h2>
      </div>
      <div class="box-show-data">
        <h5 class="fc-primary">{{ $t("redeemed") }}</h5>
        <h2>{{ redeemedForDisplay }}</h2>
      </div>
    </div>
    <div class="flex justify-center -mt-4">
      <el-button type="primary" @click="onRedeemNow" round>{{
        $t("redeem_now")
      }}</el-button>
      <el-dialog
        v-model="dialogVisible"
        :title="$t('redeem')"
        width="500px"
        destroy-on-close
      >
        <referral-modal v-if="!isLoading" />
      </el-dialog>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, watch } from "vue";

export default defineComponent({
  setup() {
    const {
      referralForDisplay,
      isLoading,
      onRedeemNow,
      rebet,
      referralCount,
      totalForDisplay,
      totalRewardForDisplay,
      redeemedForDisplay,
      redeemableForDisplay,
      dialogVisible,
    } = useReferralComponent();
    watch(
      () => dialogVisible.value,
      () => {
        const contentContainer: HTMLElement | null = document.querySelector(
          'div[layout="black_modern_desktop_1"] #content-container'
        );
        if (!contentContainer) return;

        if (dialogVisible.value) {
          contentContainer.style.zIndex = "30";
          return;
        }
        contentContainer.style.zIndex = "0";
      }
    );
    return {
      referralForDisplay,
      isLoading,
      onRedeemNow,
      totalForDisplay,
      referralCount,
      redeemedForDisplay,
      rebet,
      totalRewardForDisplay,
      redeemableForDisplay,
      dialogVisible,
    };
  },
});
</script>
<style lang="postcss" scoped>
.box-show-data {
  @apply border-r-2 flex flex-col items-center my-4 py-3 px-8;
}
.box-show-data:last-child {
  @apply border-r-0;
}
:deep(.el-dialog__title) {
  font-weight: bold;
  font-size: 20px;
  color: var(--text);
}
</style>
